#!/bin/bash

# customize if necessary
APP_NAME=XDS-Viewer
VERSION=0.6

# do not change
NAME=$APP_NAME-$VERSION

echo -e "\n>> Create/clean build folder..."
mkdir -p build
cd build

echo -e ">> Building..."

cmake ..&&make

if [ -e XDS-Viewer_OSX_MakeStandAloneBundle.cmake ]
then
	
	echo -e "\n>> CMake detected Mac OS X\n"
	echo -e "\n>> Building Application Bundle..."
        
	make install

	# check if we build application bundle for Mac OS X
	if [ -e $APP_NAME.app ]
	then
		# add wrapper script to application bundle
	
		DIR=$(pwd)	
	
		# On OS X .bashrc won't be sourced if the program is executed from application bundle.
		# Therefore it is necessary to call a script that sources .bashrc and executes the program.
		
		cd $APP_NAME.app/Contents/MacOS
		mv XDS-Viewer xds-viewer-bin
		echo -e "#!/bin/bash\n\nsource ~/.bashrc\nCURRENT_DIR=\"\$(dirname \"\$0\")\"\n\n\"\$CURRENT_DIR/xds-viewer-bin\"" > XDS-Viewer
		chmod a+x XDS-Viewer

		cd $DIR

		# create dmg image

		hdiutil create -srcfolder $APP_NAME.app $NAME.dmg
		hdiutil internet-enable -yes $NAME.dmg
		cp $NAME.dmg ../
		cd ..
		rm -rf build
	fi
else
        echo -e "\n>> Build finished. If no errors occured, proceed with \"cd build;sudo make install\"."
fi
