/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "Canvas.h"
#include <QtGui>

#include <iostream>

Canvas::Canvas( QWidget *parent ): QWidget( parent )
{
	_initialized = false;

	_colorTable = ColorTable();
}

//void Canvas::on_pbOK_clicked()
//{
//
//}

void Canvas::setImageArray( ImageArray imageArray )
{
	_imageArray = imageArray;
	_mainImage = _imageArray.toQImage();

	_initialized = true;
}

void Canvas::updateImageArray(){
	_mainImage = _imageArray.toQImage();

	_initialized = true;
}

void Canvas::setColorTable( ColorTable colorTable )
{
	_colorTable = colorTable;
	if ( _initialized )
	{
		_mainImage.setColorTable( colorTable );
	}
}

ImageArray& Canvas::getImageArray()
{
	return _imageArray;
}

QImage& Canvas::getScaledImage()
{
	return _scaledImage;
}

void Canvas::setScaledImage(QImage scaledImage)
{
	_scaledImage = scaledImage;
}

QImage& Canvas::getMainImage()
{
	return _mainImage;
}

bool Canvas::isInitialized()
{
	return _initialized;
}

void Canvas::updatePreview()
{
	//
}


void Canvas::paintEvent( QPaintEvent * event )
{
	if ( _initialized )
	{
		QPainter p( this );

		QImage scaledImage;

		//generate preview image
		_scaledImage = _mainImage.scaled( this->width(), this->height() );

		p.drawImage( 0, 0, _scaledImage );
	}
}
