/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef CBF_READER_H
#define CBF_READER_H

#include "ImageReader.h"

class CbfReader : public ImageReader
{
	public:
		virtual int readHeader( std::ifstream &file );
		virtual int readBinary( std::ifstream &file );
		virtual std::string getName() const;
	
	protected:
		virtual std::vector<std::string> getTokenList();
		int  filterComments( std::string in,
				int index, 
				std::string &out );
		int checkImageFormat( std::ifstream& tapin );
		bool isMarker( std::ifstream &tapin );
};

#endif /*CBF_READER_H*/
