/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "ColorCanvas.h"
#include <QtGui>

#include <iostream>

ColorCanvas::ColorCanvas( QWidget *parent ): QWidget( parent )
{
	_initialized = true;

	_colorTable = ColorTable();

	_mainImage = QImage( 1, 256, QImage::Format_Indexed8 );

	setColorTable(_colorTable);

	// set pixels
	for ( unsigned int y = 0; y < 256;y++ )
	{
		for ( unsigned int x = 0; x < 1; x++ )
		{
			// y is equal to 255- the color index
			_mainImage.setPixel(x,y,255-y);
		}
	}
}


void ColorCanvas::setColorTable( ColorTable colorTable )
{
	_colorTable = colorTable;
	if ( _initialized )
	{
		_mainImage.setColorTable( colorTable );
	}
}

//QImage& ColorCanvas::getScaledImage()
//{
//        return _scaledImage;
//}

//void ColorCanvas::setScaledImage(QImage scaledImage)
//{
//        _scaledImage = scaledImage;
//}

QImage ColorCanvas::getMainImage()
{
	return _mainImage;
}

bool ColorCanvas::isInitialized()
{
	return _initialized;
}

void ColorCanvas::paintEvent( QPaintEvent * event )
{
	if ( _initialized )
	{
		QPainter p( this );

		QImage scaledImage;

		//generate preview image
		_scaledImage = _mainImage.scaled( this->width(), this->height() );

		p.drawImage( 0, 0, _scaledImage );
	}
}

