/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef COLORCANVAS_H
#define COLORCANVAS_H

#include <QWidget>

#include "ColorTable.h"

/**
 *
 * The canvas class.
 *
 * It is derived from the QWidget class and will be used as custom
 * widget in the designer.
 */
class ColorCanvas : public QWidget
{
		Q_OBJECT

	public:
		/**
		 * Constructor
		 */
		ColorCanvas( QWidget *parent = NULL );

		void setColorTable( ColorTable colorTable );
		void paintEvent( QPaintEvent * event );

		bool isInitialized();

		//QImage& getScaledImage();
		void setScaledImage(QImage scaledImage);
		QImage getMainImage();

	protected slots:
		/*
		 * These slots are named by their corresponding
		 * signals. This ensures they are automatically
		 * connected. Se Qt documentation for details.
		 */
	private slots:
		//void on_pbOK_clicked();
		//void on_pbStop_clicked();

		//void on_actionQuit_triggered();

	protected:
		ColorTable _colorTable;
	private:

		QImage _mainImage;
		QImage _scaledImage;

		bool _initialized;

};
#endif /*COLORCANVAS_H*/
