/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "ColorTable.h"
#include <cmath>
#include <iostream>
ColorTable::ColorTable()
{
	//for ( unsigned int i = 0; i < MAX_COLORS; i++ )
	//{
	//        this->append( qRgb( i, i, i ) );
	//}

	for ( unsigned int i = MAX_COLORS; i > 0; i-- )
	{
		this->append( qRgb( i, i, i ) );
	}

	generate(0);
}


void ColorTable::generate( int sliderPos )
{
	for ( unsigned int i = 0; i < MAX_COLORS; i++ )
	{
		double fktValue = log( sliderPos ) * 255 / log( 255 );

		double slope = fktValue / sliderPos;

		int valueR = ( int )( i * slope );
		int valueG = ( int )( i * slope );
		int valueB = ( int )( i * slope );

		if ( i >= sliderPos )
		{
			valueR = ( int )( log( i ) * 255 / log( 255 ) );
			valueG = ( int )( log( i ) * 255 / log( 255 ) );
			valueB = ( int )( log( i ) * 255 / log( 255 ) );
		}

		( *this )[i] = qRgb( 255 - valueR, 255 - valueG, 255 - valueB );
	}
}
