/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef IMAGE_READER_H
#define IMAGE_READER_H

#include<fstream>
#include<string>
#include<vector>
#include<algorithm>
#include<iostream>
#include<sstream>

class ImageReader
{
	public:
		ImageReader();
		virtual int readHeader( std::ifstream &file ) = 0;
		virtual int readBinary( std::ifstream &file ) = 0;
		const unsigned int getNX() const;
		const unsigned int getNY() const;
		int* getMemory() const;
		void setMemory(int* memory);
		virtual std::string getName() const = 0;
	
	protected:
		virtual bool isMarker(std::ifstream &tapin) = 0;
		int stream2String( std::ifstream& tapin, std::string &out );
		virtual int filterComments(std::string in, int i,std::string &out) = 0;
		std::vector<std::string> tokenize(std::string in, char seperator = '\n');
		std::string toUpper( std::string str );
		int getTokenID( std::string s, std::vector<std::string> token );
		virtual std::vector<std::string> getTokenList() = 0;
		std::string removeWhiteSpace( std::string in, char whiteSpace );
		bool findToken( std::string token, 
				std::vector<std::string> tokenList,
				bool whiteSpaces = true);


		unsigned int _nx;
		unsigned int _ny;
		int* _memory;
};

#endif /*IMAGE_READER_H*/

