/**************************************************************************
*   Copyright (C) 2008 by Michael Hoffer <info@michaelhoffer.de>          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef VIEWCANVAS_H
#define VIEWCANVAS_H

#include "Canvas.h"

#include <QRubberBand>
#include <QMouseEvent>

class ViewCanvas : public Canvas
{
	public:
		ViewCanvas(QWidget *parent = NULL);
		
		void setListener( ValueListener *listener );
		virtual void setImageArray(ImageArray imageArray);
		void updateImageBuffer();
		void mouseMoveEvent( QMouseEvent * e );
		void mousePressEvent(QMouseEvent *e);
		void mouseReleaseEvent(QMouseEvent *e);
		void resizeEvent(QResizeEvent *event);
		void paintEvent( QPaintEvent * event );
	private:
		ValueListener *_listener;

		QImage _imageBuffer;

		QRubberBand *_zoomRect1; 

		QRect _zoomRect;
		QRect _viewRect;

		QVector<QRect> _zoomViewStack;

		double _array2MouseStepX;
		double _array2MouseStepY;

		double _mouse2ArrayStepX;
		double _mouse2ArrayStepY;

		int _mouse2ArrayOffsetX;
		int _mouse2ArrayOffsetY;
		
		void initZoomValues();
		bool computeViewRect(int x, int y);

};


#endif /*VIEWCANVAS_H*/
