/**************************************************************************
*   Copyright (C) 2007 by Michael Hoffer and Kenneth Aar                  *
*   info@michaelhoffer.de, kenneth@grafikern.no                           *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Library General Public License as       *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Library General Public     *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "helpwindow.h"
//#include <QtUiTools>
#include <QtGui>
#include <QTextStream>
#include <QFile>

HelpWindow::HelpWindow( QString fileName, QWidget *parent ): QDialog( parent )
{
	setupUi( this );

	QFile helpFile( fileName ); // Create a file handle

	if ( !helpFile.open( QFile::ReadOnly ) ) // Open the file
	{
		// handle error
		textDisplay->setPlainText("Error: file: \"" + fileName + "\" does not exist!");
	}

	else
	{
		QTextStream stream( &helpFile );

		QString text = stream.readAll();

		textDisplay->setHtml( text );
	}
}


void HelpWindow::on_pbOK_clicked()
{
	this->close();
}

void HelpWindow::updateText( QString text )
{
	textDisplay->setPlainText( text );
}
