/**************************************************************************
*   Copyright (C) 2007 by Michael Hoffer and Kenneth Aar                  *
*   info@michaelhoffer.de, kenneth@grafikern.no                           *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Library General Public License as       *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Library General Public     *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef HELPWINDOW_H
#define HELPWINDOW_H
#include <QDialog>
#include <QTextEdit>
#include <QString>
#include <QPushButton>
#include "ui_helpwindow.h"

/**
 * The helpwindow class.
 *
 * It is derived from the "ui_helpwindow.h" file created by "uic".
 */
class HelpWindow : public QDialog, private Ui::HelpWindow
{
		Q_OBJECT

	public:
		/**
		 * Constructor.
		 */
		HelpWindow( QString fileName, QWidget *parent = NULL );

		/**
		 * Updates text display of the help window.
		 */
		void updateText( QString text );
		/*
		 * These slots are named by their corresponding
		 * signals. This ensures they are automatically
		 * connected. Se Qt documentation for details.
		 */
	private slots:
		void on_pbOK_clicked();

	private:
};
#endif /*HELPWINDOW_H*/
